/********************************************************************************
 * Copyright (c) 2021-2024 Bayerische Motoren Werke Aktiengesellschaft (BMW AG)
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 ********************************************************************************/

#pragma once

#include <utility>
{% block includes %}{% endblock %}

namespace {{ ose_namespace }}::Node
{
class {{ name }} : public yase::{% block nodetype %}{% endblock %}
{
  public:
    {% block constructor %}
    {{ name }}({{node.ctor}}) :
        {{node.ctor_chain}}
    {
        {% if not node.is_leaf %}
            {% for var in node.values %}
                {{var.member}} = {{var.source}};
            {% endfor %}
        {% endif %}


        {% if node.blackboard_setter %}
            {% for var in node.blackboard_setter %}
                {% if var.source %}
                    {{var.member}} = {{ var.type }}::parse({{var.source}});
                {% endif %}
            {% endfor %}
        {% endif %}
    }
    {% endblock %}

    {% block onInit %}{% endblock %}

  private:
    {% block tick %}{% endblock %}

    void lookupAndRegisterData(yase::Blackboard& blackboard) final
    {
        {% block blackboard_getter %}{% endblock %}
    }

    {% for var in node.blackboard_setter %}
    {{var.type}} {{var.member}};
    {% endfor %}

    {% if not node.is_leaf %}
        {% for var in node.values %}
            const {{var.type}} {{var.member}};
        {% endfor %}
    {% endif %}

    {% block member_definitions %}
    {% endblock %}
    {% if node.is_leaf %}
        {{node.this.type}} {{util.member(node.this)}};
    {% endif %}
};

} // namespace {{ ose_namespace }}::Node
